#--------------------------------------------------------------------------
#
#      This is free software. You can redistribute it and/or modify under
#      the terms of the GNU General Public License.
#
#      Copyright (C) 1999 by zorgon <zorgon@sdf.lonestar.org>
#
#--------------------------------------------------------------------------

unshift(@INC,"./");
require "add_holes.pl";
require "remove_holes.pl";
require "change_holes.pl";

sub select_clist {
        my($widget, $row, $column, $event) = @_;
        $clist_selected_row=$row;
}

sub unselect_clist {
        my( $widget, $row, $column, $event ) = @_;
        $clist_selected_row=-1;
}

sub gui_holes {
    my($widget,$action,@data) = @_;
    my %base,@titles, $num_holes;
    my $win,$clist;

    @titles=("Name","Url");
    $num_holes = 0;

    if(not defined $win){
	$win = new Gtk::Window(toplevel);
	$win->set_title("Holes");
	$win->border_width(0);
	$win->signal_connect("destroy",\&destroy_window,\$win);
	$win->signal_connect("delete_event",\&destroy_window,\$win);

	my $hbox = new Gtk::HBox(0, 0);
	$hbox->set_border_width(0);
	$win->add($hbox);
	$hbox->show;

	my $frame = new Gtk::Frame;
	$frame->set_usize(500,500);
	$frame->set_border_width(5);
	$hbox->pack_start($frame,0,0,0);
	$frame->show;

	my $scrolledwin = new Gtk::ScrolledWindow (undef, undef);
	$scrolledwin->set_policy('automatic','automatic');
	$scrolledwin->set_usize(400,400);
	$frame->add($scrolledwin);
	$scrolledwin->show;

	$clist = new_with_titles Gtk::CList(@titles);
	$clist->border_width(5);
	$clist->column_titles_show();
	$clist->set_selection_mode('single');
	$clist->signal_connect("select_row",\&select_clist);
	$clist->signal_connect("unselect_row",\&unselect_clist);
	$clist_selected_row=-1;
	$scrolledwin->add($clist);
	$clist->show;
	
	my $frame = new Gtk::Frame;
	$frame->set_usize(120,400);
	$frame->set_border_width(5);
	$hbox->pack_start($frame,0,0,0);
	$frame->show;

	my $vbox = new Gtk::VBox(0, 0);
	$vbox->set_border_width(0);
	$frame->add($vbox);
	$vbox->show;
	
	my $bajout = new Gtk::Button('Add');
	$bajout->set_border_width(7);
	$bajout->signal_connect("clicked",\&add_holes,$win);
	$vbox->pack_start($bajout,0,1,0);
	$bajout->show;

	my $bsupp = new Gtk::Button('Remove');
	$bsupp->set_border_width(7);
	$bsupp->signal_connect("clicked",\&remove_holes,$win);
	$vbox->pack_start($bsupp,0,1,0);
	$bsupp->show;

	my $bmod = new Gtk::Button('Change');
	$bmod->set_border_width(7);
	$bmod->signal_connect("clicked",\&change_holes,$win);
	$vbox->pack_start($bmod,0,1,0);
	$bmod->show;

	my $bexit = new Gtk::Button('Exit');
	$bexit->set_border_width(7);
	$bexit->signal_connect("clicked",sub { destroy $win });
	$vbox->pack_start($bexit,0,1,0);
	$bexit->show;

	dbmopen(%BASE,"cgi",0777) || &message("Impossible d'ouvrir la base");
	$clist->freeze();
	foreach $keys (sort keys %BASE){
	    $clist->append("$keys","$BASE{$keys}");
	    $num_holes++;
	}
	$clist->thaw();
	dbmclose(%BASE);

	my $label = new Gtk::Label("$num_holes holes");
	$vbox->pack_end($label,0,1,0);
	$label->show;
    }

    if (!visible $win) {
	$win->show;
    } 
}

1;
