#--------------------------------------------------------------------------
#
#      This is free software. You can redistribute it and/or modify under
#      the terms of the GNU General Public License.
#
#      Copyright (C) 1999 by zorgon <zorgon@sdf.lonestar.org>
#
#--------------------------------------------------------------------------

sub destroy_window {
        my($widget, $windowref, $w2) = @_;
        $$windowref = undef;
        $w2 = undef if defined $w2;
        0;
}

sub message {
    my $dialogwindow;

    if(not defined $dialogwindow){
	$dialogwindow = new Gtk::Dialog;
	$dialogwindow->set_title("Warning !");
	$dialogwindow->signal_connect("destroy",\&destroy_window,\$dialogwindow);
	$dialogwindow->signal_connect("delete_event",\&destroy_window,\$dialogwindow);

	my $label = new Gtk::Label "@_";
	$label->set_padding(10,10);
	$dialogwindow->vbox->pack_start($label,1,1,0);
	$label->show;

	my $bok = new Gtk::Button("OK");
	$bok->signal_connect("clicked",sub { destroy $dialogwindow });
	$bok->can_default(1);
	$dialogwindow->action_area->pack_start($bok,1,1,0);
	$bok->grab_default;
	$bok->show;
    }

    if (!visible $dialogwindow) {
	$dialogwindow->show;
    }
}

sub about {
    my($widget,$action,@data) = @_;
    my $aboutwindow;

    if(not defined $aboutwindow){
	$aboutwindow = new Gtk::Dialog;
	$aboutwindow->set_title("Riven");
	$aboutwindow->signal_connect("delete_event",\&destroy_window,\$aboutwindow);
	$aboutwindow->signal_connect("destroy",\&destroy_window,\$aboutwindow);
	
	my $frame = new Gtk::Frame;
	$frame->set_usize(210,100);
	$frame->set_border_width(5);
	$aboutwindow->vbox->pack_start($frame,1,1,0);
	$frame->show;

	my $vbox = new Gtk::VBox(0,5);
	$vbox->set_border_width(5);
	$frame->add($vbox);
	$vbox->show;

	my $label = new Gtk::Label("Author : Zorgon");
	$vbox->pack_start($label,0,0,0);
	$label->show;

	my $label = new Gtk::Label("Email : zorgon\@linuxstart.com");
	$vbox->pack_start($label,0,0,0);
	$label->show;

	my $label = new Gtk::Label("Web : http://www.nightbird.free.fr");
	$vbox->pack_start($label,0,0,0);
	$label->show;

	my $bok = new Gtk::Button("OK");
	$bok->can_default(1);
	$bok->signal_connect("clicked",sub { destroy $aboutwindow });
	$bok->grab_default();
	$aboutwindow->action_area->pack_start($bok,1,1,0);
	$bok->show;
    }

    if (!$aboutwindow->visible) {
	$aboutwindow->show;
    }
}

sub save_options {
    open(FILE,">riven.conf") || &message("Can't open riven.conf");
    print FILE "#Fichier de configuration de riven\n";
 
    if(!defined($PROXY)) { $PROXY = 'no'; }
    print FILE "\$PROXY = '$PROXY'\;\n";
    
    if(!defined($PORT_PROXY)) { $PORT_PROXY = 8080; }
    print FILE "\$PORT_PROXY = $PORT_PROXY\;\n";
    
    if(!defined($URL_PROXY)) { $URL_PROXY = ''; }
    print FILE "\$URL_PROXY = '$URL_PROXY'\;\n";
    
    if(!defined($CASE)) { $CASE = 'no'; }
    print FILE "\$CASE = '$CASE'\;\n";
    
    if(!defined($INSERT)) { $INSERT = 'no'; }
    print FILE "\$INSERT = '$INSERT'\;\n";
    
    if(!defined($DELEMITER)) { $DELEMITER = 'no'; }
    print FILE "\$DELEMITER = '$DELEMITER'\;\n";
    
    if(!defined($RANDOM)) { $RANDOM = 'no'; }
    print FILE "\$RANDOM = '$RANDOM'\;\n";
    
    if(!defined($FAKE)) { $FAKE = ''; }
    print FILE "\$FAKE = '$FAKE'\;\n";
    
    if(!defined($BROWSER)) { $BROWSER = ''; }
    print FILE "\$BROWSER = '$BROWSER'\;\n";

    if(!defined($REFERRER)) { $REFERRER = ''; }
    print FILE "\$REFERRER = '$REFERRER'\;\n";
    
    if(!defined($CGIREP)) { $CGIREP = ''; }
    print FILE "\$CGIREP = '$CGIREP'\;\n";
    
    if(!defined($HOST)) { $HOST = ''; }
    print FILE "\$HOST = '$HOST'\;\n";
    
    if(!defined($PORT)) { $PORT = ''; }
    print FILE "\$PORT = '$PORT'\;\n";
    
    close(FILE);
}

sub random_str {
    my $str;
    my @car = ("a" .. "z");
    
    $str = join ("", @car[ map { rand @car} (1 .. 8)]);
    return $str;
}

1;

